import { Injectable } from '@nestjs/common';
import { BaseIndexManager } from 'src/core/modules/domain/usecase/managers/base-index.manager';
import { UserPrivilegeConfigurationEntity } from '../../../entities/user-privilege-configuration.entity';
import { Param } from 'src/core/helpers/query/specific-search.helper';
import { SelectQueryBuilder } from 'typeorm';

@Injectable()
export class IndexUserPrivilegeConfigurationManager extends BaseIndexManager<UserPrivilegeConfigurationEntity> {
  async prepareData(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get specificFilter(): Param[] {
    return;
  }

  setQueryFilter(
    queryBuilder: SelectQueryBuilder<UserPrivilegeConfigurationEntity>,
  ): SelectQueryBuilder<UserPrivilegeConfigurationEntity> {
    console.log(this.filterParam, 'param');
    if (this.filterParam.user_privilege_ids) {
      queryBuilder.andWhere(`user_privilege_id In (:...privilegeIds)`, {
        privilegeIds: this.filterParam.user_privilege_ids,
      });
    }

    return queryBuilder;
  }
}
